<?php
/*
Plugin Name: GetSimple Contact
Description: Simple contact form plugin for GetSimple
Version: 1.1.1
Author: Kolyok
Author URI: http://get-simple.info/forums/member.php?action=profile&uid=7989
 */

$thisfile_sc = basename(__FILE__, ".php");

i18n_merge($thisfile_sc) || i18n_merge($thisfile_sc, 'en_US');

register_plugin(
        $thisfile_sc,
        i18n_r($thisfile_sc . '/SC_TITLE'),
        '1.1.1',
        'Kolyok',
        'http://get-simple.info/forums/member.php?action=profile&uid=7989',
        i18n_r($thisfile_sc . '/SC_DESC'),
        'plugins',
        'sc_backend'
);

add_action('plugins-sidebar', 'createSideMenu', array($thisfile_sc, i18n_r($thisfile_sc . '/SC_TITLE_ADMIN')));
add_action('index-pretemplate','sc_generate_token');
add_filter('content','sc_frontend');

$settings_file = GSDATAOTHERPATH .'getsimple_contact_settings.xml';
$settings_update = array('CAPTCHA_TYPE'=>array('captcha_type'=>2),'RECAPTCHA_STATUS'=>array('recaptcha_status'=>0),
                        'SUPERADMIN_NAME'=>array('superadmin_name'=>'Mr. Change Me'),'SUPERADMIN_EMAIL'=>array('superadmin_email'=>'mr@change.me'));
sc_be_update_settings($settings_update);

function sc_backend() {
    if (isset($_POST) && $_POST) {
        sc_save_settings($_POST);
        echo sc_be_content();
    } else {
        echo sc_be_content();
    }
}

function sc_frontend() {
    global $content;
    if (preg_match('#\[sc_form(.*)\]#', $content)) {
        if (isset($_POST) && $_POST) {
            return sc_mail($_POST);
        } else {
            return sc_content();
        }
    } else {
        return sc_content();
    }
}

function sc_content($error=null) {
    global $content;
    $form = sc_render_form($error);
    $content = preg_replace('#\[sc_form(.*)\]#', $form, $content);
    return $content;
}

function sc_render_form($error=null) {
    global $thisfile_sc;
    $settings = sc_get_settings();
    $token = sc_get_token();
    $form = sc_scripts();
    if (count($error)>0) {
        $err = array();
        $err['name'] = isset($error['name'])?$error['name']:'';
        $err['subject'] = isset($error['subject'])?$error['subject']:'';
        $err['email'] = isset($error['email'])?$error['email']:'';
        $err['message'] = isset($error['message'])?$error['message']:'';
        $err['captcha'] = isset($error['captcha'])?$error['captcha']:'';
        $err['success'] = isset($error['success_message'])?$error['success_message']:'';
        $err['php_mailer'] = isset($error['php_mailer'])?$error['php_mailer']:'';
        $err['invalid_form'] = isset($error['invalid_form'])?$error['invalid_form']:'';
    } else {
        $err = array('name'=>'','subject'=>'','email'=>'','message'=>'','captcha'=>'','success'=>'','php_mailer'=>'','invalid_form'=>'');
    }
    if ($settings['captcha_type']==1) {
        if ($settings['recaptcha_status']==1) {
            require_once GSPLUGINPATH.'getsimple_contact/inc/recaptchalib.php';
            $captcha_form = '<label for="recaptcha_response_field" class="sc-label">'.i18n_r($thisfile_sc . '/SC_FE_CAPTCHA').'</label>
                                <span id="sc-captcha-error" class="sc-error">'.$err['captcha'].'</span>
                                <div class="sc-clear"></div>
                                <div id="recaptcha_widget" class="sc-recaptcha-widget" style="display:none">
                                <input type="text" id="recaptcha_response_field" name="recaptcha_response_field" class="sc-text" />
                                <div class="sc-recaptcha-reload" onclick="javascript:Recaptcha.reload()">'.i18n_r($thisfile_sc . '/SC_FE_CAPTCHA_RELOAD').'</div>
                                <div class="recaptcha_only_if_image sc-recaptcha-audio" onclick="javascript:Recaptcha.switch_type(\'audio\');">'.i18n_r($thisfile_sc . '/SC_FE_CAPTCHA_GET_AUDIO').'</div>
                                <div class="recaptcha_only_if_audio sc-recaptcha-image" onclick="javascript:Recaptcha.switch_type(\'image\');">'.i18n_r($thisfile_sc . '/SC_FE_CAPTCHA_GET_IMAGE').'</div>
                                <div class="sc-clear"></div>
                                <div id="recaptcha_image" class="sc-recaptcha-img"></div>
                                <div class="sc-clear"></div>
                              </div>
                              <script type="text/javascript" src="http://www.google.com/recaptcha/api/challenge?k='.$settings['recaptcha_public_key'].'"></script>
                              <noscript>
                                <iframe src="http://www.google.com/recaptcha/api/noscript?k='.$settings['recaptcha_public_key'].'" frameborder="0" class="sc-recaptcha-frame"></iframe>
                                <textarea name="recaptcha_challenge_field" class="sc-recaptcha-text-area"></textarea>
                                <input type="hidden" name="recaptcha_response_field" value="manual_challenge">
                              </noscript>';
        } else {
            $captcha_form = '';
        }
    } else if ($settings['captcha_type']==0) {
        require_once GSPLUGINPATH.'getsimple_contact/process/process.php';
        $captcha_form = '<label for="recaptcha_response_field" class="sc-label">'.i18n_r($thisfile_sc . '/SC_FE_CAPTCHA').'</label>
                                <span id="sc-captcha-error" class="sc-error">'.$err['captcha'].'</span>
                                <div class="sc-clear"></div>
                                <div id="opencaptcha_widget" class="sc-opencaptcha-widget">
                                <input type="text" id="opencaptcha_response_field" name="opencaptcha_response_field" class="sc-text" />
                                <div class="sc-opencaptcha-reload" onclick="ReloadCaptcha()">'.i18n_r($thisfile_sc . '/SC_FE_CAPTCHA_RELOAD').'</div>
                                <div class="sc-clear"></div>
                                <div id="opencaptcha_image" class="sc-opencaptcha-img">'.sc_get_opencaptcha_image().'</div>
                                <div class="sc-clear"></div>
                              </div>';
    } else {
        $captcha_form = '';
    }
    $form .= '<div class="sc-success">'.$err['success'].'</div>
            <div class="sc-error">'.$err['php_mailer'].'</div>
            <div class="sc-error">'.$err['invalid_form'].'</div>
            <div class="sc-clear"></div>
            <form id="sc-contact" method="post">
                <label for="name" class="sc-label">'.i18n_r($thisfile_sc . '/SC_FE_NAME').'</label>
                <span class="sc-error">'.$err['name'].'</span>
                <input type="text" name="name" id="name" class="sc-text" />
                
                <label for="subject" class="sc-label">'.i18n_r($thisfile_sc . '/SC_FE_SUBJECT').'</label>
                <span class="sc-error">'.$err['subject'].'</span>
                <input type="text" name="subject" id="subject" class="sc-text" />
                
                <label for="email" class="sc-label">'.i18n_r($thisfile_sc . '/SC_FE_EMAIL').'</label>
                <span class="sc-error">'.$err['email'].'</span>
                <input type="text" name="email" id="email" class="sc-text" />
                
                <div id="toolbar" style="display: none;">
                    <ul class="sc-toolbar-container">
                        <li><a data-wysihtml5-command="bold" title="'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_BOLD_TITLE').'" class="sc-bold"></a></li>
                        <li><a data-wysihtml5-command="italic" title="'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_ITALIC_TITLE').'" class="sc-italic"></a></li>
                        <li><a data-wysihtml5-command="createLink" title="'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_INSERT_LINK_TITLE').'" class="sc-insert-link"></a></li>
                        <li><a data-wysihtml5-command="insertImage" title="'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_INSERT_IMAGE_TITLE').'" class="sc-insert-image"></a></li>
                        <li><a data-wysihtml5-command="formatBlock" data-wysihtml5-command-value="h1" title="'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_INSERT_H1_TITLE').'" class="sc-insert-h1"></a></li>
                        <li><a data-wysihtml5-command="formatBlock" data-wysihtml5-command-value="h2" title="'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_INSERT_H2_TITLE').'" class="sc-insert-h2"></a></li>
                        <li><a data-wysihtml5-command="insertUnorderedList" title="'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_INSERT_UL_TITLE').'" class="sc-insert-ul"></a></li>
                        <li><a data-wysihtml5-command="insertOrderedList" title="'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_INSERT_OL_TITLE').'" class="sc-insert-ol"></a></li>
                        <li><a data-wysihtml5-command="foreColor" data-wysihtml5-command-value="red" title="'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_INSERT_RED_TITLE').'" class="sc-insert-red"></a></li>
                        <li><a data-wysihtml5-command="foreColor" data-wysihtml5-command-value="green" title="'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_INSERT_GREEN_TITLE').'" class="sc-insert-green"></a></li>
                        <li><a data-wysihtml5-command="foreColor" data-wysihtml5-command-value="blue" title="'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_INSERT_BLUE_TITLE').'" class="sc-insert-blue"></a></li>
                        <li><a data-wysihtml5-command="undo" title="'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_UNDO_TITLE').'" class="sc-undo"></a></li>
                        <li><a data-wysihtml5-command="redo" title="'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_REDO_TITLE').'" class="sc-redo"></a></li>
                        <li><a data-wysihtml5-action="change_view" title="'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_SWITCH_TO_SOURCE_TITLE').'" class="sc-switch-to-source"></a></li>
                    </ul>
                    <div data-wysihtml5-dialog="createLink" class="sc-insert-link-container" style="display: none;">
                        <label class="sc-label">'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_INSERT_LINK_LABEL').'</label>
                        <label class="sc-label"><input data-wysihtml5-dialog-field="href" value="http://" class="sc-text"></label>
                        <a data-wysihtml5-dialog-action="save" title="'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_INSERT_LINK_OK_TITLE').'" class="sc-ok"></a>
                        <a data-wysihtml5-dialog-action="cancel" title="'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_INSERT_LINK_CANCEL_TITLE').'" class="sc-cancel"></a>
                    </div>
                    <div data-wysihtml5-dialog="insertImage" style="display: none;">
                        <label class="sc-label">'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_INSERT_IMAGE_LABEL').'</label>
                        <label class="sc-label"><input data-wysihtml5-dialog-field="src" value="http://" class="sc-text"></label>
                        <label class="sc-label">
                            <select data-wysihtml5-dialog-field="className" class="sc-select">
                                <option value="">'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_IMAGE_ALIGN_SELECT_DEFAULT').'</option>
                                <option value="wysiwyg-float-left">'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_IMAGE_ALIGN_SELECT_LEFT').'</option>
                                <option value="wysiwyg-float-right">'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_IMAGE_ALIGN_SELECT_RIGHT').'</option>
                            </select>
                        </label>

                        <a data-wysihtml5-dialog-action="save" title="'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_INSERT_IMAGE_OK_TITLE').'" class="sc-ok"></a>
                        <a data-wysihtml5-dialog-action="cancel" title="'.i18n_r($thisfile_sc . '/SC_FE_EDITOR_INSERT_IMAGE_CANCEL_TITLE').'" class="sc-cancel"></a>
                    </div>
                </div>
                
                <label for="message" class="sc-label">'.i18n_r($thisfile_sc . '/SC_FE_MESSAGE').'</label>
                <span class="sc-error">'.$err['message'].'</span>
                <textarea name="message" id="message" class="sc-text-area"></textarea>
                '.$captcha_form.'
                <input type="hidden" id="token" name="token" value="'.$token.'">
                <input type="submit" name="submit" value="'.i18n_r($thisfile_sc . '/SC_FE_SUBMIT').'" class="sc-submit" />
                <div class="sc-clear"></div>
            </form>';
    return $form;
}

function sc_scripts() {
    global $SITEURL,$thisfile_sc;
    $settings = sc_get_settings();
    if ($settings['captcha_type']==1) {
        if ($settings['recaptcha_status']==1) {
            $captcha = 'recaptcha_response_field: {
                            required: true
                        }';
            $captcha_msg = 'recaptcha_response_field: "'.i18n_r($thisfile_sc . '/SC_FE_CAPTCHA_REQUIRED').'"';
            $captcha_widget = 'var RecaptchaOptions = {
                                    theme : "custom",
                                    custom_theme_widget: "recaptcha_widget"
                                };';
        } else {
            $captcha = '';
            $captcha_msg = '';
            $captcha_widget = '';
        }
    } else if ($settings['captcha_type']==0) {
        $captcha = 'opencaptcha_response_field: {
                        required: true
                    }';
        $captcha_msg = 'opencaptcha_response_field: "'.i18n_r($thisfile_sc . '/SC_FE_CAPTCHA_REQUIRED').'"';
        $captcha_widget = 'function ReloadCaptcha() {
                                $.get(\''.$SITEURL.'plugins/getsimple_contact/process/process.php\', function(data) {
                                    $(\'#opencaptcha_image\').html(data);
                                });
                            }';
    } else {
        $captcha = '';
        $captcha_msg = '';
        $captcha_widget = '';
    }
    $style = '<link rel="stylesheet" type="text/css" href="'.$SITEURL.'plugins/getsimple_contact/css/simple_contact.css"></link>';
    $script = '<script>window.jQuery || document.write(\'<script src="'.$SITEURL.'plugins/getsimple_contact/js/jquery-1.10.2.min.js"><\/script>\')</script>';
    $script .= '<script type="text/javascript" src="'.$SITEURL.'plugins/getsimple_contact/js/jquery.validate.min.js"></script>';
    $script .= '<script type="text/javascript" src="'.$SITEURL.'plugins/getsimple_contact/js/advanced.js"></script>';
    $script .= '<script type="text/javascript" src="'.$SITEURL.'plugins/getsimple_contact/js/wysihtml5-0.4.0pre.min.js"></script>';
    $script .= '<script type="text/javascript">
                jQuery(document).ready(function() {
                    $(\'#sc-contact\').validate({
                        ignore: "",
                        errorPlacement: function(error, element) {
                            if (error[0].htmlFor=="recaptcha_response_field" || error[0].htmlFor=="opencaptcha_response_field") {
                                $("#sc-captcha-error").html("");
                                error.appendTo("#sc-captcha-error");
                            } else {
                                element.prev("span").html("");
                                error.appendTo( element.prev("span") );
                            }
                        }, 
                        rules: {
                            name: {
                                required: true
                            },
                            subject: {
                                required: true
                            },
                            email: {
                                required: true,
                                email: true
                            },
                            message: {
                                required: true,
                                minlength: 1
                            },
                            '.$captcha.'
                        },
                        messages: {
                            name: "'.i18n_r($thisfile_sc . '/SC_FE_NAME_REQUIRED').'",
                            subject: "'.i18n_r($thisfile_sc . '/SC_FE_SUBJECT_REQUIRED').'",
                            email: {
                                required: "'.i18n_r($thisfile_sc . '/SC_FE_EMAIL_REQUIRED').'",
                                email: "'.i18n_r($thisfile_sc . '/SC_FE_EMAIL_INVALID').'"
                            },
                            message: "'.i18n_r($thisfile_sc . '/SC_FE_MESSAGE_REQUIRED').'",
                            '.$captcha_msg.'
                        }
                    });
                    var editor = new wysihtml5.Editor("message", {
                      toolbar: "toolbar",
                      stylesheets: "'.$SITEURL.'plugins/getsimple_contact/css/stylesheet.css",
                      parserRules: wysihtml5ParserRules
                    });
                });
                '.$captcha_widget.'
                </script>';
    return $style.$script;
}

function sc_mail($data) {
    global $thisfile_sc;
    $data = sc_check_post($data);
    if ($data['valid']==true) {
        $settings = sc_get_settings();
        require_once GSPLUGINPATH.'getsimple_contact/inc/class.phpmailer.php';
        require_once GSPLUGINPATH.'getsimple_contact/inc/class.html2text.php';
        $nonHTML = new html2text($data['message']);
        $mail = new PHPMailer;
        $recipients = sc_get_recipients();
        $mail->setLanguage('en_US',GSPLUGINPATH.'getsimple_contact/lang/');
        $mail->CharSet = 'UTF-8';
        $mail->From = $data['email'];
        $mail->FromName = $data['name'];
        foreach ($recipients as $recipient) {
            foreach ($recipient as $key => $value) {
                $mail->addAddress($key, $value);
            }
        }
        $mail->addReplyTo($data['email'], $data['name']);
        $mail->WordWrap = 50;
        $mail->isHTML(true);

        $mail->Subject = $data['subject'];
        $mail->Body = $data['message'];
        $mail->AltBody = $nonHTML->get_text();
        
        if (!$mail->send()) {
            $content = sc_content(array('php_mailer'=>i18n_r($thisfile_sc . '/'.$mail->ErrorInfo)));
            return $content;
        } else {
            $content = sc_content(array('success_message'=>i18n_r($thisfile_sc . '/SC_FE_MESSAGE_SENT'),'success'=>true));
            return $content;
        }
    } else {
        $content = sc_content($data['error']);
        return $content;
    }
}

function sc_check_post($data) {
    global $thisfile_sc;
    $check = sc_is_whitelisted($data);
    if ($check) {
        $settings = sc_get_settings();
        $error = array();
        if (isset($data['name'])) {
            $data['name'] = strip_tags($data['name']);
            $data['name'] = trim($data['name']);
            $data['name'] = stripslashes($data['name']);
            $data['name'] = htmlspecialchars($data['name']);
            if (empty($data['name']) || is_null($data['name']) || $data['name']=='') {
                $error['name'] = i18n_r($thisfile_sc . '/SC_FE_NAME_REQUIRED');
            }
        } else {
            $error['name'] = i18n_r($thisfile_sc . '/SC_FE_NAME_REQUIRED');
        }
        if (isset($data['subject'])) {
            $data['subject'] = strip_tags($data['subject']);
            $data['subject'] = trim($data['subject']);
            $data['subject'] = stripslashes($data['subject']);
            $data['subject'] = htmlspecialchars($data['subject']);
            if (empty($data['subject']) || is_null($data['subject']) || $data['subject']=='') {
                $error['subject'] = i18n_r($thisfile_sc . '/SC_FE_SUBJECT_REQUIRED');
            }
        } else {
            $error['subject'] = i18n_r($thisfile_sc . '/SC_FE_SUBJECT_REQUIRED');
        }
        if (isset($data['email'])) {
            $data['email'] = strip_tags($data['email']);
            $data['email'] = trim($data['email']);
            if (empty($data['email']) || is_null($data['email']) || $data['email']=='') {
                $error['email'] = i18n_r($thisfile_sc . '/SC_FE_EMAIL_REQUIRED');
            } else {
                if (!filter_var($data['email'], FILTER_VALIDATE_EMAIL)) {
                    $error['email'] = i18n_r($thisfile_sc . '/SC_FE_EMAIL_INVALID');
                }
            }
        } else {
            $error['email'] = i18n_r($thisfile_sc . '/SC_FE_EMAIL_REQUIRED');
        }
        if (isset($data['message'])) {
            $data['message'] = trim($data['message']);
            $temp = strip_tags($data['message']);
            $temp = html_entity_decode($temp);
            $temp = preg_replace('~\x{00a0}~siu','',$temp);
            if (empty($temp) || is_null($temp) || $temp=='') {
                $error['message'] = i18n_r($thisfile_sc . '/SC_FE_MESSAGE_REQUIRED');
            } else {
                $allowed = '<span><br><i><b><a><img><h1><h2><ul><ol><li>';
                $data['message'] = strip_tags($data['message'],$allowed);
            }
        } else {
            $error['message'] = i18n_r($thisfile_sc . '/SC_FE_MESSAGE_REQUIRED');
        }
        if (isset($data['token'])) {
            $token_array = sc_get_token_array();
            if (empty($data['token']) || is_null($data['token']) || $data['token']=='') {
                $data['valid'] = false;
                $data['error'] = array('invalid_form'=>i18n_r($thisfile_sc . '/SC_FE_INVALID_FORM_SUBMIT'));
                sc_log_attempts('invalid_token', $token_data, '');
                return $data;
            } else {
                if (!in_array($data['token'], $token_array)) {
                    $data['valid'] = false;
                    $data['error'] = array('invalid_form'=>i18n_r($thisfile_sc . '/SC_FE_INVALID_FORM_SUBMIT'));
                    sc_log_attempts('invalid_token', $token_data, $data['token']);
                    return $data;
                }
            }
        } else {
            $data['valid'] = false;
            $data['error'] = array('invalid_form'=>i18n_r($thisfile_sc . '/SC_FE_INVALID_FORM_SUBMIT'));
            return $data;
        }
        if ($settings['captcha_type']==1) {
            if ($settings['recaptcha_status']==1) {
                require_once GSPLUGINPATH.'getsimple_contact/inc/recaptchalib.php';
                if (isset($data['recaptcha_challenge_field']) && isset($data['recaptcha_response_field'])) {
                    $privatekey = $settings['recaptcha_private_key'];
                    $resp = recaptcha_check_answer ($privatekey,
                            $_SERVER["REMOTE_ADDR"],
                            $data["recaptcha_challenge_field"],
                            $data["recaptcha_response_field"]);
                    if (!$resp->is_valid) {
                        $error['captcha'] = i18n_r($thisfile_sc . '/SC_FE_'.strtoupper($resp->error));
                    }
                } else {
                    $error['captcha'] = i18n_r($thisfile_sc . '/SC_FE_INCORRECT-CAPTCHA-SOL');
                }
            }
        } else if ($settings['captcha_type']==0) {
            if (isset($data['opencaptcha_challenge_field']) && isset($data['opencaptcha_response_field'])) {
                $check = sc_check_opencaptcha($data['opencaptcha_response_field'],$data['opencaptcha_challenge_field']);
                if (!$check) {
                    $error['captcha'] = i18n_r($thisfile_sc . '/SC_FE_INCORRECT-CAPTCHA-SOL');
                }
            } else {
                 $error['captcha'] = i18n_r($thisfile_sc . '/SC_FE_INCORRECT-CAPTCHA-SOL');
            }
        }
        if (count($error)>0) {
            $data['valid'] = false;
            $data['error'] = $error;
            return $data;
        } else {
            $data['valid'] = true;
            return $data;
        }
    } else {
        $data['valid'] = false;
        $data['error'] = array('invalid_form'=>i18n_r($thisfile_sc . '/SC_FE_INVALID_FORM_SUBMIT'));
        return $data;
    }
}

function sc_save_settings($data) {
    $xml = new SimpleXMLExtended('<ITEM></ITEM>');
    $xml->addChild('SUPERADMIN_NAME',$data['superadmin_name']);
    $xml->addChild('SUPERADMIN_EMAIL',$data['superadmin_email']);
    $xml->addChild('RECIPIENT_NAME',$data['recipient_name']);
    $xml->addChild('RECIPIENT_EMAIL',$data['recipient_email']);
    $xml->addChild('CAPTCHA_TYPE',$data['captcha_type']);
    $xml->addChild('RECAPTCHA_STATUS',$data['recaptcha_status']);
    $xml->addChild('RECAPTCHA_PUBLIC_KEY',$data['recaptcha_public_key']);
    $xml->addChild('RECAPTCHA_PRIVATE_KEY',$data['recaptcha_private_key']);
    
    if (! XMLsave($xml, GSDATAOTHERPATH .'getsimple_contact_settings.xml') ) {
        $error = '<div class="error"><p>'.i18n_r('CHMOD_ERROR').'</p></div>';
        echo $error;
    } else {
        $success = '<div class="updated"><p>'.i18n_r('SETTINGS_UPDATED').'</p></div>';
        echo $success;
    }
}

function sc_get_settings() {
    global $settings_file;
    if (file_exists($settings_file)) {
        $settings = getXML($settings_file);
    } else {
        $xml = new SimpleXMLExtended('<ITEM></ITEM>');
        $xml->addChild('SUPERADMIN_NAME','Mr. Change Me');
        $xml->addChild('SUPERADMIN_EMAIL','mr@change.me');
        $xml->addChild('RECIPIENT_NAME','Mr. Change Me');
        $xml->addChild('RECIPIENT_EMAIL','mr@change.me');
        $xml->addChild('CAPTCHA_TYPE',2);
        $xml->addChild('RECAPTCHA_STATUS',0);
        $xml->addChild('RECAPTCHA_PUBLIC_KEY','6Ldz6OgSAAAAAGgYwOZEH4E-9V0EK9e8zjmVmMoi');
        $xml->addChild('RECAPTCHA_PRIVATE_KEY','6Ldz6OgSAAAAADR6CmMpe6qUEgLeQ7xCQ-5FUqAC');

        if (! XMLsave($xml, GSDATAOTHERPATH .'getsimple_contact_settings.xml') ) {
            $error = '<div class="error"><p>'.i18n_r('CHMOD_ERROR').'</p></div>';
        } else {
            $settings = getXML($settings_file);
            $success = '<div class="updated"><p>'.i18n_r('SETTINGS_UPDATED').'</p></div>';
        }
    }
    $data = array('superadmin_name'=>$settings->SUPERADMIN_NAME,
                'superadmin_email'=>$settings->SUPERADMIN_EMAIL,
                'recipient_name'=>$settings->RECIPIENT_NAME,
                'recipient_email'=>$settings->RECIPIENT_EMAIL,
                'captcha_type'=>$settings->CAPTCHA_TYPE,
                'recaptcha_status'=>$settings->RECAPTCHA_STATUS,
                'recaptcha_public_key'=>$settings->RECAPTCHA_PUBLIC_KEY,
                'recaptcha_private_key'=>$settings->RECAPTCHA_PRIVATE_KEY);
    return $data;
}

function sc_be_content() {
    global $thisfile_sc,$SITEURL;
    $settings = sc_get_settings();
    if ($settings['recaptcha_status']==0) {
        $disabled = ' selected';
        $enabled = '';
    } else if ($settings['recaptcha_status']==1) {
        $disabled = '';
        $enabled = ' selected';
    }
    if ($settings['captcha_type']==0) {
        $current0 = ' selected';
        $current1 = '';
        $current2 = '';
    } else if ($settings['captcha_type']==1) {
        $current0 = '';
        $current1 = ' selected';
        $current2 = '';
    } else if ($settings['captcha_type']==2) {
        $current0 = '';
        $current1 = '';
        $current2 = ' selected';
    }
    $form = '<form id="sc-contact" method="post">';
    $form .= '<p>
                <label for="superadmin_name" class="sc-label">'.i18n_r($thisfile_sc . '/SC_BE_SUPERADMIN_NAME').'</label>
                <input type="text" name="superadmin_name" id="superadmin_name" class="text" value="'.$settings['superadmin_name'].'" />
                </p>
                <p>
                <label for="superadmin_email" class="sc-label">'.i18n_r($thisfile_sc . '/SC_BE_SUPERADMIN_EMAIL').'</label>
                <input type="text" name="superadmin_email" id="superadmin_email" class="text" value="'.$settings['superadmin_email'].'" />
                </p>
                <p>'.i18n_r($thisfile_sc . '/SC_BE_SUPERADMIN_DESC').'</p>
                <p>
                <label for="recipient_name" class="sc-label">'.i18n_r($thisfile_sc . '/SC_BE_RECIPIENT_NAME').'</label>
                <input type="text" name="recipient_name" id="recipient_name" class="text" value="'.$settings['recipient_name'].'" />
                </p>
                <p>
                <label for="recipient_email" class="sc-label">'.i18n_r($thisfile_sc . '/SC_BE_RECIPIENT_EMAIL').'</label>
                <input type="text" name="recipient_email" id="recipient_email" class="text" value="'.$settings['recipient_email'].'" />
                </p>
                <p>
                <label for="captcha_type" class="sc-label">'.i18n_r($thisfile_sc . '/SC_BE_CAPTCHA_TYPE').'</label>
                <select id="captcha_type" name="captcha_type" class="text">
                    <option value="0"'.$current0.'>'.i18n_r($thisfile_sc . '/SC_BE_CAPTCHA_SELECT_OPENCAPTCHA').'</option>
                    <option value="1"'.$current1.'>'.i18n_r($thisfile_sc . '/SC_BE_CAPTCHA_SELECT_RECAPTCHA').'</option>
                    <option value="2"'.$current2.'>'.i18n_r($thisfile_sc . '/SC_BE_CAPTCHA_SELECT_NOCAPTCHA').'</option>
                </select>
                </p>
                <div id="show_opencaptcha">
                    <p>'.i18n_r($thisfile_sc . '/SC_BE_OPENCAPTCHA_DESC').'</p>
                    <p>'.i18n_r($thisfile_sc . '/SC_BE_OPENCAPTCHA_LINK').'</p>
                </div>
                <div id="show_recaptcha">
                <p>
                <label for="recaptcha_status" class="sc-label">'.i18n_r($thisfile_sc . '/SC_BE_RECAPTCHA_STATUS').'</label>
                <select id="recaptcha_status" name="recaptcha_status" class="text">
                    <option value="0"'.$disabled.'>'.i18n_r($thisfile_sc . '/SC_BE_RECAPTCHA_SELECT_DISABLED').'</option>
                    <option value="1"'.$enabled.'>'.i18n_r($thisfile_sc . '/SC_BE_RECAPTCHA_SELECT_ENABLED').'</option>
                </select>
                </p>
                <p>
                <label for="recaptcha_public_key" class="sc-label">'.i18n_r($thisfile_sc . '/SC_BE_RECAPTCHA_PUBLIC_KEY').'</label>
                <input type="text" name="recaptcha_public_key" id="recaptcha_public_key" class="text" value="'.$settings['recaptcha_public_key'].'" />
                </p>
                <p>
                <label for="recaptcha_private_key" class="sc-label">'.i18n_r($thisfile_sc . '/SC_BE_RECAPTCHA_PRIVATE_KEY').'</label>
                <input type="text" name="recaptcha_private_key" id="recaptcha_private_key" class="text" value="'.$settings['recaptcha_private_key'].'" />
                </p>
                <p>'.i18n_r($thisfile_sc . '/SC_BE_RECAPTCHA_DESC').'</p>
                <p>'.i18n_r($thisfile_sc . '/SC_BE_RECAPTCHA_LINK').'</p>
                </div>
                <div id="submit_line">
                <span><input type="submit" name="submit" value="'.i18n_r($thisfile_sc . '/SC_FE_BE_SUBMIT').'" class="submit" /></span>
                </div>
            </form>
            <script>window.jQuery || document.write(\'<script src="'.$SITEURL.'plugins/getsimple_contact/js/jquery-1.10.2.min.js"><\/script>\')</script>
            <script type="text/javascript">
            jQuery(document).ready(function() {
                var count = 0;
                if($(\'#captcha_type\').val()===\'0\') {
                    $(\'#show_recaptcha\').hide();
                    var hidden = 1;
                } else if($(\'#captcha_type\').val()===\'1\') {
                    $(\'#show_opencaptcha\').hide();
                    var hidden = 2;
                } else if($(\'#captcha_type\').val()===\'2\') {
                    $(\'#show_recaptcha\').hide();
                    $(\'#show_opencaptcha\').hide();
                    var hidden = 0;
                }
                $(\'#captcha_type\').on(\'change keyup\', function() {
                    if($(\'#captcha_type\').val()===\'0\') {
                        if (this.value == $(this).data(\'curr_val\'))
                            return false;
                        if (hidden == 1 || hidden == 2) {
                            $(\'#show_recaptcha\').slideToggle(\'slow\');
                            $(\'#show_opencaptcha\').slideToggle(\'slow\');
                        } else if (hidden == 0) {
                            $(\'#show_opencaptcha\').slideToggle(\'slow\');
                        }
                        hidden = 1;
                        $(this).data(\'curr_val\', this.value);
                    } else if($(\'#captcha_type\').val()===\'1\') {
                        if (this.value == $(this).data(\'curr_val\'))
                            return false;
                        if (hidden == 1 || hidden == 2) {
                            $(\'#show_opencaptcha\').slideToggle(\'slow\');
                            $(\'#show_recaptcha\').slideToggle(\'slow\');
                        } else if (hidden == 0) {
                            $(\'#show_recaptcha\').slideToggle(\'slow\');
                        }
                        hidden = 2;
                        $(this).data(\'curr_val\', this.value);
                    } else if($(\'#captcha_type\').val()===\'2\') {
                        if (this.value == $(this).data(\'curr_val\'))
                            return false;
                        $(\'#show_recaptcha\').hide();
                        $(\'#show_opencaptcha\').hide();
                        hidden = 0;
                        $(this).data(\'curr_val\', this.value);
                    }
                });
            });
            </script>';
    $icons = '<p>'.i18n_r($thisfile_sc . '/SC_BE_ICONS_LINK').'</p>';
    return $form.$icons;
}

function sc_be_update_settings($data) {
    $settings = sc_get_settings();
    $old = count($settings);
    foreach ($data as $key => $value) {
        foreach ($value as $key2 => $value2) {
            if (empty($settings[$key2])) {
                $settings[$key2] = $value2;
                sc_save_settings($settings);
            }
        }
    }
    $new = count($settings);
    if ($new>$old) {
        return true;
    } else {
        return false;
    }
}

function sc_get_recipients() {
    $settings = sc_get_settings();
    $nameArray = explode(',', $settings['recipient_name']);
    $emailArray = explode(',', $settings['recipient_email']);
    foreach ($nameArray as $key => $value) {
        if ($value=='' || empty($value) || is_null($value)) {
            unset($nameArray[$key]);
        }
    }
    foreach ($emailArray as $key => $value) {
        if ($value=='' || empty($value) || is_null($value)) {
            unset($emailArray[$key]);
        }
    }
    $na = count($nameArray);
    $ea = count($emailArray);
    $new = array();
    if ($na==$ea) {
        for ($i=0; $i<$na; $i++) {
            $new[$i] = array(trim($emailArray[$i])=>trim($nameArray[$i]));
        }
    } else if($na>$ea) {
        for ($i=0; $i<$ea; $i++) {
            $new[$i] = array(trim($emailArray[$i])=>trim($nameArray[$i]));
        }
    } else if ($ea>$na) {
        for ($i=0; $i<$na; $i++) {
            $new[$i] = array(trim($emailArray[$i])=>trim($nameArray[$i]));
        }
    }
    return $new;
}

function sc_check_opencaptcha($opencaptcha_response_field,$opencaptcha_challenge_field) {
    if(sc_file_get_contents("http://www.opencaptcha.com/validate.php?ans=".$opencaptcha_response_field."&img=".$opencaptcha_challenge_field)=='pass') {
        return true;
    } else {
        return false;
    }
}

 function sc_file_get_contents($url){
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_URL, $url);
    $data = curl_exec($ch);
    curl_close($ch);
    return $data;
}

function sc_is_whitelisted($data) {
    $settings = sc_get_settings();
    $whitelist = array('name','subject','email','message','_wysihtml5_mode',
                        'recaptcha_response_field','recaptcha_challenge_field',
                        'opencaptcha_response_field','opencaptcha_challenge_field',
                        'token','submit');
    if ($settings['captcha_type']==0) {
        unset($whitelist[5]);
        unset($whitelist[6]);
    } else if ($settings['captcha_type']==1) {
        if ($settings['recaptcha_status']==1) {
            unset($whitelist[7]);
            unset($whitelist[8]);
        } else {
            unset($whitelist[5]);
            unset($whitelist[6]);
            unset($whitelist[7]);
            unset($whitelist[8]);
        }
    } else {
        unset($whitelist[5]);
        unset($whitelist[6]);
        unset($whitelist[7]);
        unset($whitelist[8]);
    }
    foreach ($data as $key => $value) {
        if (!in_array($key, $whitelist)) {
            sc_log_attempts('invalid_form_data',$whitelist,$data);
            return false;
        }
    }
    return true;
}

function sc_log_attempts($type,$param1=null,$param2=null) {
    global $thisfile_sc,$SITEURL;
    require_once GSPLUGINPATH.'getsimple_contact/inc/class.phpmailer.php';
    require_once GSPLUGINPATH.'getsimple_contact/inc/class.html2text.php';
    $settings = sc_get_settings();
    $ip = $_SERVER['REMOTE_ADDR'];
    $host = gethostbyaddr($ip);
    $date = date('Y. m. d. H:i');
    if ($type=='invalid_form_data') {
        $enabled = '';
        $posted = '';
        foreach ($param1 as $key => $value) {
            $enabled .= $value.', ';
        }
        foreach ($param2 as $key => $value) {
            $posted .= $key.', ';
        }
    } else {
        $enabled = '';
        $posted = '';
    }
    $enabled = substr($enabled, 0, -2);
    $posted = substr($posted, 0, -2);
    $subject = i18n_r($thisfile_sc . '/SC_FE_LOG_SUBJECT_START').get_site_name(false).i18n_r($thisfile_sc . '/SC_FE_LOG_SUBJECT_END');
    $log = i18n_r($thisfile_sc . '/SC_FE_LOG_MESSAGE_START').get_site_name(false).' - '.  get_page_clean_title(false).i18n_r($thisfile_sc . '/SC_FE_LOG_MESSAGE_END').'<br/><br/>';
    $log .= i18n_r($thisfile_sc . '/SC_FE_LOG_MESSAGE_DETAILS').'<br/>';
    $log .= i18n_r($thisfile_sc . '/SC_FE_LOG_MESSAGE_DATE').$date.'<br/>';
    $log .= i18n_r($thisfile_sc . '/SC_FE_LOG_MESSAGE_SITE').$SITEURL.'<br/>';
    $log .= i18n_r($thisfile_sc . '/SC_FE_LOG_MESSAGE_IP').$ip.'<br/>';
    $log .= i18n_r($thisfile_sc . '/SC_FE_LOG_MESSAGE_HOST').$host.'<br/>';
    $log .= i18n_r($thisfile_sc . '/SC_FE_LOG_MESSAGE_TYPE').$type.'<br/>';
    if ($type=='invalid_form_data') {
        $log .= i18n_r($thisfile_sc . '/SC_FE_LOG_MESSAGE_WHITELIST').$enabled.'<br/>';
        $log .= i18n_r($thisfile_sc . '/SC_FE_LOG_MESSAGE_POSTED').$posted.'<br/>';
    } else if ($type=='invalid_token') {
        $log .= i18n_r($thisfile_sc . '/SC_FE_LOG_MESSAGE_CORRECT_TOKEN').$param1.'<br/>';
        $log .= i18n_r($thisfile_sc . '/SC_FE_LOG_MESSAGE_FALSE_TOKEN').$param2.'<br/>';
    }
    $nonHTML = new html2text($log);
    $mail = new PHPMailer;
    $mail->setLanguage('en_US',GSPLUGINPATH.'getsimple_contact/lang/');
    $mail->CharSet = 'UTF-8';
    $mail->From = $settings['superadmin_email'];
    $mail->FromName = $settings['superadmin_name'];
    $mail->addAddress($settings['superadmin_email'], $settings['superadmin_name']);
    $mail->WordWrap = 50;
    $mail->isHTML(true);
    $mail->Subject = $subject;
    $mail->Body = $log;
    $mail->AltBody = $nonHTML->get_text();
    $mail->send();
}

function sc_generate_token() {
    if (!isset($_SESSION)) {
        @session_start();
        @session_set_cookie_params('180', '/', '', false, true);
    }
    if (isset($_SESSION['token'][1]) && !isset($_SESSION['token'][2]) && !isset($_SESSION['token'][3]) && !isset($_SESSION['token'][4])) {
        $_SESSION['token'][2] = $_SESSION['token'][1];
        $_SESSION['token'][1] = md5(uniqid(microtime(), true));
    } else if (isset($_SESSION['token'][1]) && isset($_SESSION['token'][2]) && !isset($_SESSION['token'][3]) && !isset($_SESSION['token'][4])) {
        $_SESSION['token'][3] = $_SESSION['token'][2];
        $_SESSION['token'][2] = $_SESSION['token'][1];
        $_SESSION['token'][1] = md5(uniqid(microtime(), true));
    } else if (isset($_SESSION['token'][1]) && isset($_SESSION['token'][2]) && isset($_SESSION['token'][3]) && !isset($_SESSION['token'][4])) {
        $_SESSION['token'][4] = $_SESSION['token'][3];
        $_SESSION['token'][3] = $_SESSION['token'][2];
        $_SESSION['token'][2] = $_SESSION['token'][1];
        $_SESSION['token'][1] = md5(uniqid(microtime(), true));
    } else if (isset($_SESSION['token'][1]) && isset($_SESSION['token'][2]) && isset($_SESSION['token'][3]) && isset($_SESSION['token'][4])) {
        $_SESSION['token'][5] = $_SESSION['token'][4];
        $_SESSION['token'][4] = $_SESSION['token'][3];
        $_SESSION['token'][3] = $_SESSION['token'][2];
        $_SESSION['token'][2] = $_SESSION['token'][1];
        $_SESSION['token'][1] = md5(uniqid(microtime(), true));
    } else {
        $_SESSION['token'][1] = md5(uniqid(microtime(), true));
    }
}

function sc_get_token() {
    return $_SESSION['token'][1];
}

function sc_get_token_array() {
    return $_SESSION['token'];
}